Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp	(revision 27519)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp	(revision 27537)
@@ -255,5 +255,5 @@
 
     BOOL fSyntheticCpu;
-    machine->GetCpuProperty(CpuPropertyType_Synthetic, &fSyntheticCpu);
+    machine->GetCPUProperty(CPUPropertyType_Synthetic, &fSyntheticCpu);
     if (details == VMINFO_MACHINEREADABLE)
         RTPrintf("synthcpu=\"%s\"\n", fSyntheticCpu ? "on" : "off");
@@ -273,5 +273,5 @@
         {
             ULONG uEAX, uEBX, uECX, uEDX;
-            rc = machine->GetCpuIdLeaf(uLeaf, &uEAX, &uEBX, &uECX, &uEDX);
+            rc = machine->GetCPUIDLeaf(uLeaf, &uEAX, &uEBX, &uECX, &uEDX);
             if (SUCCEEDED(rc))
             {
@@ -392,5 +392,5 @@
 
     BOOL PAEEnabled;
-    machine->GetCpuProperty(CpuPropertyType_PAE, &PAEEnabled);
+    machine->GetCPUProperty(CPUPropertyType_PAE, &PAEEnabled);
     if (details == VMINFO_MACHINEREADABLE)
         RTPrintf("pae=\"%s\"\n", PAEEnabled ? "on" : "off");
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageList.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageList.cpp	(revision 27519)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageList.cpp	(revision 27537)
@@ -454,5 +454,5 @@
             {
                 ULONG uEAX, uEBX, uECX, uEDX, cLeafs;
-                CHECK_ERROR(Host, GetProcessorCpuIdLeaf(uCpuNo, s_auCpuIdRanges[i], 0, &cLeafs, &uEBX, &uECX, &uEDX));
+                CHECK_ERROR(Host, GetProcessorCPUIDLeaf(uCpuNo, s_auCpuIdRanges[i], 0, &cLeafs, &uEBX, &uECX, &uEDX));
                 if (cLeafs < s_auCpuIdRanges[i] || cLeafs > s_auCpuIdRanges[i+1])
                     continue;
@@ -460,5 +460,5 @@
                 for (ULONG iLeaf = s_auCpuIdRanges[i]; iLeaf <= cLeafs; iLeaf++)
                 {
-                    CHECK_ERROR(Host, GetProcessorCpuIdLeaf(uCpuNo, iLeaf, 0, &uEAX, &uEBX, &uECX, &uEDX));
+                    CHECK_ERROR(Host, GetProcessorCPUIDLeaf(uCpuNo, iLeaf, 0, &uEAX, &uEBX, &uECX, &uEDX));
                     RTPrintf("%08x  %08x %08x %08x %08x\n", iLeaf, uEAX, uEBX, uECX, uEDX);
                 }
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 27519)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 27537)
@@ -379,5 +379,5 @@
             case MODIFYVM_PAE:
             {
-                CHECK_ERROR(machine, SetCpuProperty(CpuPropertyType_PAE, ValueUnion.f));
+                CHECK_ERROR(machine, SetCPUProperty(CPUPropertyType_PAE, ValueUnion.f));
                 break;
             }
@@ -385,5 +385,5 @@
             case MODIFYVM_SYNTHCPU:
             {
-                CHECK_ERROR(machine, SetCpuProperty(CpuPropertyType_Synthetic, ValueUnion.f));
+                CHECK_ERROR(machine, SetCPUProperty(CPUPropertyType_Synthetic, ValueUnion.f));
                 break;
             }
@@ -415,5 +415,5 @@
                     aValue[i] = ValueUnion.u32;
                 }
-                CHECK_ERROR(machine, SetCpuIdLeaf(id, aValue[0], aValue[1], aValue[2], aValue[3]));
+                CHECK_ERROR(machine, SetCPUIDLeaf(id, aValue[0], aValue[1], aValue[2], aValue[3]));
                 break;
             }
@@ -421,5 +421,5 @@
             case MODIFYVM_DELCPUID:
             {
-                CHECK_ERROR(machine, RemoveCpuIdLeaf(ValueUnion.u32));
+                CHECK_ERROR(machine, RemoveCPUIDLeaf(ValueUnion.u32));
                 break;
             }
@@ -427,5 +427,5 @@
             case MODIFYVM_DELALLCPUID:
             {
-                CHECK_ERROR(machine, RemoveAllCpuIdLeafs());
+                CHECK_ERROR(machine, RemoveAllCPUIDLeaves());
                 break;
             }